<?php


namespace Controller;

use Traits\TResponse;
use Zeedhi\Framework\DTO\Request;
use Service\Project as ProjectService;

class Project
{
    use TResponse;

    /**
     * @var ProjectService
     */
    private $projectService;

    public function __construct(ProjectService $projectService)
    {
        $this->projectService = $projectService;
    }

    public function findProjectsByOperador(Request $request)
    {
        try {
            $projects = $this->projectService->findProjectsByOperador();
            $this->sendResponse($projects, 200);
        } catch (\Exception $e) {
            $this->sendResponse($this->createResponseError($e), 500);
        }
    }
}
