/* Sistemas Integrados TEKNISA
    
Nome: 9501_CVIVIEO_ETL_CONTARECEBIDA

Descrio: view que retorna AS CONTAS RECEBIDAS POR DATA DE BAIXA (ANO E MES)

Criao:
04/07/2012 - Ftima Fernandes
*/


CREATE OR REPLACE FORCE VIEW "DM_CONTARECEBIDA" ("CDEMPRESA", "CDFILIAL", "NMFILIALEMIT", 
"NMFANTCLIE", "NMRAZSOCCLIE", "NMTIPOCONTA", "CDREDUCONT", "DSCONTACORRENTE", "DSCONTCORR", "NMTIPOBAIXA",
 "CDANOBI", "CDMESBI", "DSDOCSERIE","DSDESCRICAO","VRBRUTOBOLETOREC", "VRLIQUIDOBOLETOREC", "VRAJUSTEBOLETOREC", "VRORIGREC",
 "VRAJUSTECTREC", "VRRECEBIDO", "QTCONTAS", "QTDIASRECEBIDOS", "QTDIASATRASO", "QTBOLEMATRASO")
AS
SELECT BO.CDEMPRESA, BA.CDFILIAL, F.CDFILIAL || '-' || F.NMFILIAL AS NMFILIALENIT, CL.NMFANTCLIE,
    CL.NMRAZSOCCLIE,  CT.CDTPCTRECEB || '-' || TP.DSTPCTRECEB as NMTIPOCONTA,
    BA.CDREDUCONT, NMBANCO ||'-'||CDAGENCIA ||'-' ||CDCONTCORR AS DSCONTACORRENTE,
    CC.DSCONTCORR, TB.CDTPBAIXAREC || '-' || TB.NMTPBAIXAREC AS NMTIPOBAIXA,
    TO_CHAR(BA.DTBAIXAREC, 'YYYY') AS CDANOBI,
    TO_CHAR(BA.DTBAIXAREC, 'MM') AS CDMESBI,
    (NF.NRNOTAFISC||'/'||NF.CDSERIE||' - Baixa:'||BA.DTBAIXAREC) DOC_SERIE,
    (CT.DSCONTAREC) DESCRICAO,
    (ROUND(BO.VRBOLREC, 2)) VRBRUTOBOLETOREC,
    (ROUND(BO.VRFINALBREC, 2)) VRLIQUIDOBOLETOREC,
    (ROUND(BO.VRFINALBREC, 2) - ROUND(BO.VRBOLREC, 2)) VRAJUSTEBOLETOREC,
    SUM(ROUND(CT.VRORIGREC, 2)) VRINICIALREC,
    SUM(ROUND(VRATUAREC, 2)- ROUND(CT.VRORIGREC, 2)) VRAJUSTCTREC,
    SUM(ROUND(CT.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CT.VRATUAREC/BO.VRBOLREC))) VRRECEBIDO,
    COUNT(*) AS QTCONTAS,
    (TRUNC(SYSDATE) - TRUNC(BA.DTBAIXAREC) ) AS QTDIASRECEBIDOS,
    (CASE WHEN BA.DTBAIXAREC > BO.DTVENBOLREC THEN ROUND(BA.DTBAIXAREC - BO.DTVENBOLREC)  ELSE 0  END) QTDIASRECEMATR,
    (CASE WHEN BA.DTBAIXAREC > BO.DTVENBOLREC THEN 1 ELSE 0 END) QTBOLRECEMATR
  FROM CONTARECEBER CT, BOLETRECEBER BO, BAIXARECEBIDA BA, CLIENTE CL,
    TIPOCTRECEBER TP, CONTCORR CC, BANCO B, NOTAFISCAL NF, FILIAL F, TIPOBAIXAREC TB
  WHERE BO.CDFILIAL   = CT.CDFILIBOLREC
  AND BO.NRLANBOLREC  = CT.NRLANBOLREC
  AND BO.VRFINALBREC <> 0
  AND BA.CDFILIAL     = BO.CDFILIBAIREC
  AND BA.NRBAIXAREC   = BO.NRBAIXAREC
  AND BA.IDSTATUSBREC = 'E'
  AND CL.CDCLIENTE    = BO.CDCLIENTE
  AND TP.CDTPCTRECEB  = CT.CDTPCTRECEB
  AND CC.CDREDUCONT   = BA.CDREDUCONT
  AND CC.CDBANCO      = B.CDBANCO
  AND CT.NRLANCTONF   = NF.NRLANCTONF
  AND CT.CDFILIAL     = NF.CDFILIAL
  AND NF.CDFILIEMIT   = F.CDFILIAL
  AND BA.CDTPBAIXAREC = TB.CDTPBAIXAREC
  GROUP BY BO.CDEMPRESA, BA.CDFILIAL, F.CDFILIAL , F.NMFILIAL, CL.NMFANTCLIE, CL.NMRAZSOCCLIE, CT.CDTPCTRECEB,
  TP.DSTPCTRECEB, BA.CDREDUCONT, NMBANCO ,CDAGENCIA ,CDCONTCORR, CC.DSCONTCORR, TB.CDTPBAIXAREC , TB.NMTPBAIXAREC,
  BA.DTBAIXAREC, NF.DTENTRSAID,BO.DTVENBOLREC, BO.VRBOLREC, BO.VRFINALBREC, NF.NRNOTAFISC, NF.CDSERIE, CT.DSCONTAREC
/
BEGIN
--Fatos--
	CRIA_FATOS('DM_CONTARECEBIDA', 'VRBRUTOBOLETOREC'  	,'Vlr. Bruto do Bol.'			,'Valor Bruto do Boleto'	      		,'Cont. a Rec. - Baixa Receb.');
	CRIA_FATOS('DM_CONTARECEBIDA', 'VRLIQUIDOBOLETOREC'	,'Vlr. Lq. do Bol.'			,'Valor Lquido do Boleto'	      		,'Cont. a Rec. - Baixa Receb.');
	CRIA_FATOS('DM_CONTARECEBIDA', 'VRAJUSTEBOLETOREC'	,'Vlr. de Ajuste do Bol.'		,'Valor de Ajuste Boleto'	      		,'Cont. a Rec. - Baixa Receb.');
	CRIA_FATOS('DM_CONTARECEBIDA', 'VRORIGREC'			,'Vlr. Ini. da Cont. a Rec.'	,'Valor Inicial da Conta a Receber'	    ,'Cont. a Rec. - Baixa Receb.');
	CRIA_FATOS('DM_CONTARECEBIDA', 'VRAJUSTECTREC'		,'Vlr. de Ajus. Cont. a Rece.'	,'Valor de Ajuste da Conta a Receber'	,'Cont. a Rec. - Baixa Receb.');
	CRIA_FATOS('DM_CONTARECEBIDA', 'VRRECEBIDO'			,'Vlr. Recebido'					,'Valor Recebido'	              		,'Cont. a Rec. - Baixa Receb.');
	CRIA_FATOS('DM_CONTARECEBIDA', 'QTCONTAS'   		,'Quant. de Contas'				,'Quantidade de Contas'		      		,'Cont. a Rec. - Baixa Receb.');
	CRIA_FATOS('DM_CONTARECEBIDA', 'QTDIASRECEBIDOS'	,'Dias Recebidos'				,'Quantidade de Dias Recebidos'       	,'Cont. a Rec. - Baixa Receb.');
	CRIA_FATOS('DM_CONTARECEBIDA', 'QTDIASATRASO'    	,'Quant. de dias em atraso'		,'Quantidade de dias em o Atraso'     	,'Cont. a Rec. - Baixa Receb.');
	CRIA_FATOS('DM_CONTARECEBIDA', 'QTBOLEMATRASO'    	,'Quant. Bol. em atraso'		,'Quantidade de Boleto em o Atraso'   	,'Cont. a Rec. - Baixa Receb.');

--Dimenso
	CRIA_DIME('DM_CONTARECEBIDA'	,'CDEMPRESA'		,'Empresa'						,'EMPRESA','CDEMPRESA'  ,'NMEMPRESA'  	,NULL); 
	CRIA_DIME('DM_CONTARECEBIDA'	,'CDFILIAL'			,'Filial'						,'FILIAL' ,'CDFILIAL'   ,'NMFILIAL'   	,NULL);
 CRIA_DIME('DM_CONTARECEBIDA'	,'NMFILIALEMIT'		,'Filial de Emisso'			,NULL	  ,NULL		 	,NULL		  	,NULL);
 CRIA_DIME('DM_CONTARECEBIDA'	,'NMFANTCLIE'		,'Nome Fantasia'				,NULL	  ,NULL		  	,NULL		  	,NULL);
 CRIA_DIME('DM_CONTARECEBIDA'	,'NMRAZSOCCLIE'		,'Razo Social'					,NULL	  ,NULL		  	,NULL		  	,NULL);
	CRIA_DIME('DM_CONTARECEBIDA'	,'NMTIPOCONTA'		,'Tipo de Conta'				,NULL	  ,NULL		  	,NULL		  	,NULL);
	CRIA_DIME('DM_CONTARECEBIDA'	,'CDREDUCONT'		,'Cdigo Reduzido'				,NULL	  ,NULL		  	,NULL		  	,NULL);
	CRIA_DIME('DM_CONTARECEBIDA'	,'DSCONTACORRENTE'	,'Conta Corrente'				,NULL	  ,NULL		  	,NULL		  	,NULL);
	CRIA_DIME('DM_CONTARECEBIDA'	,'NMTIPOBAIXA'		,'Tipo de Baixa'				,NULL	  ,NULL		  	,NULL		  	,NULL);
	CRIA_DIME('DM_CONTARECEBIDA'	,'CDANOBI'			,'Ano'							,NULL	  ,NULL		  	,NULL		  	,NULL);
 CRIA_DIME('DM_CONTARECEBIDA'	,'CDMESBI'			,'Ms'							,NULL	  ,NULL		  	,NULL		  	,NULL);
 CRIA_DIME('DM_CONTARECEBIDA'	,'DSDOCSERIE'			,'Doc/Srie'							,NULL	  ,NULL		  	,NULL		  	,NULL);
 CRIA_DIME('DM_CONTARECEBIDA'	,'DSDESCRICAO'			,'Descrio'							,NULL	  ,NULL		  	,NULL		  	,NULL);
END;
/
	
-- VERSAO --
BEGIN ATUVEROBJ('DM_CONTARECDTVENC','5.09.105'); END;
/