/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCONT                                                 */
/* Tabela : TIPOCONT                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 17/08/2004 - Welbert G. Moitinha                                           */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOCONT'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOCONT
GO

CREATE TRIGGER DTULTATU_TIPOCONT
ON TIPOCONT
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOCONT', null, 'CDTIPOCONT=' + CDTIPOCONT + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOCONT
      SET DTULTATUTPCO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOCONT.CDTIPOCONT,0) = ISNULL(INSERTED.CDTIPOCONT,0)) AND
            (ISNULL(TIPOCONT.NMTIPOCONT,0) = ISNULL(INSERTED.NMTIPOCONT,0)) ;
   END;
END;
GO